	org 32768

    xor a
    out ($fe),a
    ld hl,22528
    ld de,22529
    ld bc,767
    ld a,7
    ld (hl),a
    ldir

    ld hl,20480
    ld de,20481
    ld bc,2047
    ld a,128
    ld (hl),a
    ldir
    ld hl,20480
    ld de,20481
    ld bc,255
    ld a,255
    ld (hl),a
    ldir

main_loop:
	halt
	call one_scroll
	ld bc,$7ffe
	in a,(c)
	and 1
	jr nz, main_loop
	ret

one_scroll:
	ld a,(bpos)
	or a
	jr z,move_text
	dec a
	ld (bpos),a
	jr do_scroll
move_text:
	ld a,7
	ld (bpos),a
text_adr: equ $+1
	ld hl,text
	ld a,(hl)
	inc hl
	ld (text_adr),hl
	cp 13
	jr nz,get_char
	ld hl,text
	ld a,(hl)
	inc hl
	ld (text_adr),hl
get_char:
	ld h,0
	ld l,a
	add hl,hl
	add hl,hl
	add hl,hl
	ld de,15360
	add hl,de
	ld de,buf
	rept 8
	  ldi
	endm

do_scroll:
	ld hl,23040
	ld de,buf
	ld b,8
loop1:
	ld a,(de)
	rla
	ld (de),a
    jr c,is_set
    ld a,7
    jr is_reset
is_set:
    ld a,63
is_reset:
    push de
    push bc
    push hl
    pop de
    inc hl
    rept 31
      ldi
    endm
    ld (de),a
    pop bc
    pop de
    inc de
    djnz loop1

	ret

buf:	ds 8
bpos:	db 0
text:	defm "Scrollery, czesc 2 (c) 2012 mat for speccy.pl...   "
	db 13
	end 32768